#include <GL/glew.h>
#include <GL/glut.h>    
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <cmath>
#include <time.h>
#include <iostream>
#include <fstream>
//#include "opencv2/opencv.hpp"
#include "vect.h"
#include "settings.h"
#include "framebufferabstract.h"	
#include "wereld.h"
#include <string>
#include <stdint.h>
#include <png.h>
using namespace std;

float degrad(float degrees)
{
	float radians=(degrees/180.0)*M_PI;
	return radians;
}

const float refradforfacet=1.732050808; // want wortel van 3

float howmuchbiggerismyfacet(float x,float y) // het near-vlak van het viewfrustrum heeft als coordinaten (-1,-1,1) tot (1,1,1) waarbij ik er vanuit ga dat de afstand van oog-centerpoint tot een van de hoekpunten 1 is, dus de oppervlakte van de pixel daar is ook 1
{
	if(PERSPECTSPAN!=90.0) printf("howmuchbiggerismyfacet klopt niet want je functie is slechts berekend op een hoek van 90 graden....\n");
	return 1.0+(2.0*(refradforfacet-sqrt(pow(x,2.0)+pow(y,2.0)+1.0))); //want oppervlakt 1 at 1,1,1 enzo. En dan hoe verder voorbij dat vlak neemt de oppervlakte per 1 stap 2 toe vanwege perspectief...
	
}

void drawtexturedquad(float l,float r,float u,float d) //Ive been down so long it looks like up to me
{
	glBegin(GL_TRIANGLES); 
		//glColor3f(1,1,1);
		
		glTexCoord2f(0,0); glVertex3f(l,d,0);
		glTexCoord2f(1.0,0); glVertex3f(r,d,0);
		glTexCoord2f(1.0,1.0); glVertex3f(r,u,0);

		glTexCoord2f(0,0); glVertex3f(l,d,0);
		glTexCoord2f(1.0,1.0); glVertex3f(r,u,0);
		glTexCoord2f(0,1.0); glVertex3f(l,u,0);
	glEnd();
}

framebufferobject::framebufferobject(int width, int height)
{
	zetmij(width,height,true,false,false,false,false,false,PERSPECTSPAN);
}

framebufferobject::framebufferobject(int width, int height,bool linear)
{
	zetmij(width,height,!linear,false,false,false,false,false,PERSPECTSPAN);
}

framebufferobject::framebufferobject(int width, int height,bool linear,bool depth)
{
	zetmij(width,height,!linear,depth,false,false,false,false,PERSPECTSPAN);
}

framebufferobject::framebufferobject(int width, int height,bool linear,bool depth,bool repeat)
{
	zetmij(width,height,!linear,depth,repeat,false,false,false,PERSPECTSPAN);
}

framebufferobject::framebufferobject(int width, int height,bool linear,bool depth,bool repeat,bool mipmap)
{
	zetmij(width,height,!linear,depth,repeat,mipmap,false,false,PERSPECTSPAN);
}

framebufferobject::framebufferobject(int width, int height,bool linear,bool depth,bool repeat,bool mipmap,bool floating)
{
	zetmij(width,height,!linear,depth,repeat,mipmap,floating,false,PERSPECTSPAN);
}

framebufferobject::framebufferobject(int width, int height,bool linear,bool depth,bool repeat,bool mipmap,bool floating,bool alpha)
{
	zetmij(width,height,!linear,depth,repeat,mipmap,floating,alpha,PERSPECTSPAN);
}


framebufferobject::framebufferobject(int width, int height,bool linear,bool depth,bool repeat,bool mipmap,bool floating,bool alpha,float perspectiefgrootte)
{
	zetmij(width,height,!linear,depth,repeat,mipmap,floating,alpha,perspectiefgrootte);
}


framebufferobject::~framebufferobject()
{
	if(texturedata!=NULL) delete[] texturedata;
	texturedata=NULL;
}

float *framebufferobject::readtexdata()
{	
	bindframebuffer();
	glReadPixels(0,0,W,H,GL_RGB,GL_FLOAT,texturedata);
	return texturedata;
}

void framebufferobject::zetmij(int width,int height,bool near_lin,bool doeikdiepte,bool repeat,bool mipmap,bool floating,bool alpha,float perspectiefgrootte)
{
	metfloat=floating;
	metalpha=alpha;
	mijnperspectiefhoek=perspectiefgrootte;
	metmipmaps=mipmap;
	netgeframebuffered=false;
	ikbendeelvanpanorama=false;
	metdiepte=doeikdiepte;		
	drawbufs[0]=GL_COLOR_ATTACHMENT0;
	W=width;
	H=height;
	if(!alpha) texturedata=new float[W*H*3];
	else texturedata=new float[W*H*4];

	glGenFramebuffers(1, &FramebufferName);
	glGenTextures(1, &renderedTexture);
	glBindTexture(GL_TEXTURE_2D, renderedTexture);
	
	if(near_lin)
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		if(mipmap)	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_NEAREST);
		else		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	}else{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		if(mipmap)	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
		else		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	}
	
	if(mipmap && USEANISOTROPICFILTERING)
	{
		GLfloat fLargest;
		glGetFloatv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, &fLargest);	
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, fLargest);
		
	}
	
	if(!repeat)
	{
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP_TO_EDGE);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP_TO_EDGE);
	}else{
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_MIRRORED_REPEAT);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_MIRRORED_REPEAT);
	}
	
	if(!alpha)
	{
		if(!floating)
			glTexImage2D(GL_TEXTURE_2D, 0,GL_RGB, W, H, 0,GL_RGB, GL_UNSIGNED_BYTE, NULL);
		else
			glTexImage2D(GL_TEXTURE_2D, 0,GL_RGB32F, W, H, 0,GL_RGB, GL_FLOAT, NULL);
	}else{
		if(!floating)
			glTexImage2D(GL_TEXTURE_2D, 0,GL_RGBA, W, H, 0,GL_RGBA, GL_UNSIGNED_BYTE, NULL);
		else
			glTexImage2D(GL_TEXTURE_2D, 0,GL_RGBA32F, W, H, 0,GL_RGBA, GL_FLOAT, NULL);
	}
	
	glBindFramebuffer(GL_FRAMEBUFFER, FramebufferName); 
	glFramebufferTexture2D(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, renderedTexture, 0);
	glDrawBuffers(1,drawbufs);
	if(metdiepte)
	{
		glGenTextures(1, &depthTexture);
		glBindTexture(GL_TEXTURE_2D, depthTexture);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT,W, H, 0, GL_DEPTH_COMPONENT, GL_FLOAT, 0);
		
		glFramebufferTexture(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT,  depthTexture, 0);
		/*glGenRenderbuffers(1, &depthBuffer);
		glBindRenderbuffer(GL_RENDERBUFFER, depthBuffer);
		glRenderbufferStorage(GL_RENDERBUFFER, GL_DEPTH_COMPONENT24, W, H);
		glFramebufferRenderbufferEXT(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_RENDERBUFFER, depthBuffer);*/
	}
	glBindFramebuffer(GL_FRAMEBUFFER, FramebufferName); 
	glDrawBuffers(1,drawbufs);
	
	glClearColor(0.0, 0.0, 0.0, 0.0);
   	if(metdiepte) glClearDepth(1.0f);
   	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   	
   	
   	if(metdiepte)
   	{
	   	glEnable(GL_DEPTH_TEST);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();				// Reset The Projection Matrix
	    	glViewport(0,0,W,H);
	    	gluPerspective(mijnperspectiefhoek,(GLfloat)(W)/(GLfloat)(H),FBGLNEAR,FBGLFAR);	// Calculate The Aspect Ratio Of The Window
	    	glMatrixMode(GL_MODELVIEW);
	}else{
		glDisable(GL_DEPTH_TEST);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();				// Reset The Projection Matrix
	    	glViewport(0,0,W,H);
	    	glOrtho(0,W,0,H,-1.0f,1.0f);
	    	glMatrixMode(GL_MODELVIEW);
	}
}

framebufferobject::framebufferobject(int resolutie,float hoek,float dichtbij)
{
	metfloat=true;
	metmipmaps=false;
	metalpha=false;
	netgeframebuffered=false;
	ikbendeelvanpanorama=true;
	mijnperspectiefhoek=hoek;
	mijnglnear=dichtbij;
	drawbufs[0]=GL_COLOR_ATTACHMENT0;
	W=resolutie;
	H=VERTICAALMINDER;
	texturedata=new float[W*H*3];

	glGenFramebuffers(1, &FramebufferName);
	glGenTextures(1, &renderedTexture);
	glBindTexture(GL_TEXTURE_2D, renderedTexture);
	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP_TO_EDGE);
	
	
	glTexImage2D(GL_TEXTURE_2D, 0,GL_RGB, W, H, 0,GL_RGB, GL_FLOAT, NULL);

	
	glBindFramebuffer(GL_FRAMEBUFFER, FramebufferName); 
	glFramebufferTexture2D(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, renderedTexture, 0);
	glDrawBuffers(1,drawbufs);
	
/*	glGenRenderbuffers(1, &depthBuffer);
	glBindRenderbuffer(GL_RENDERBUFFER, depthBuffer);
	glRenderbufferStorage(GL_RENDERBUFFER, GL_DEPTH_COMPONENT24, W, H);
	glFramebufferRenderbufferEXT(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_RENDERBUFFER, depthBuffer);*/
	
	
	glGenTextures(1, &depthTexture);
	glBindTexture(GL_TEXTURE_2D, depthTexture);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT,W, H, 0, GL_DEPTH_COMPONENT, GL_FLOAT, 0);
	
	glFramebufferTexture(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT,  depthTexture, 0);
	
	glBindFramebuffer(GL_FRAMEBUFFER, FramebufferName); 
	glDrawBuffers(1,drawbufs);
	
	//glClearColor(0.0, 0.0, 0.0, 0.0);
	glClearColor(0.3f, 0.3f, 0.7f, 0.0f);
   	if(metdiepte) glClearDepth(1.0f);
   	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   	
   	glEnable(GL_DEPTH_TEST);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();				// Reset The Projection Matrix
    	glViewport(0,0,W,H);
    	
    	gluPerspective(PANORAMAVERTICALVIEWANGLE,mijnperspectiefhoek/PANORAMAVERTICALVIEWANGLE,mijnglnear,100.0f);	// Calculate The Aspect Ratio Of The Window
    	glMatrixMode(GL_MODELVIEW);
	
}


void framebufferobject::genereermipmaps()
{
	//bindtexture(); //niet aanzetten want deze functie wordt ook daar aangeroepen
	glGenerateMipmap(GL_TEXTURE_2D);
}

void framebufferobject::bindframebuffer()
{
	netgeframebuffered=true;
	glBindFramebuffer(GL_FRAMEBUFFER, FramebufferName); 
	glDrawBuffers(1,drawbufs);
	
	if(ikbendeelvanpanorama)
	{
		glClearColor(0.3f, 0.3f, 0.7f, 0.0f);
		glEnable(GL_DEPTH_TEST);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();				// Reset The Projection Matrix
	    	glViewport(0,0,W,H);
	   	gluPerspective(PANORAMAVERTICALVIEWANGLE,mijnperspectiefhoek/PANORAMAVERTICALVIEWANGLE,mijnglnear,100.0f);	// Calculate The Aspect Ratio Of The Window
	    	glMatrixMode(GL_MODELVIEW);
		return;
	}else glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	
	
	if(metdiepte)
	{
		
		glEnable(GL_DEPTH_TEST);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();				// Reset The Projection Matrix
	    	glViewport(0,0,W,H);
	    	gluPerspective(mijnperspectiefhoek,(GLfloat)(W)/(GLfloat)(H),FBGLNEAR,FBGLFAR);	// Calculate The Aspect Ratio Of The Window
	    	glMatrixMode(GL_MODELVIEW);
	 }else{
		glDisable(GL_DEPTH_TEST);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();				// Reset The Projection Matrix
	    	glViewport(0,0,W,H);
	    	glOrtho(0,W,0,H,-1.0f,1.0f);
	    	glMatrixMode(GL_MODELVIEW);
	}  
}

float framebufferobject::getnear()
{
	return mijnglnear;
}

void framebufferobject::binddepthtexture()
{
	glBindTexture(GL_TEXTURE_2D, depthTexture); 
	if(metmipmaps && netgeframebuffered) genereermipmaps();
	netgeframebuffered=false;            
}


void framebufferobject::bindtexture()
{
	glBindTexture(GL_TEXTURE_2D, renderedTexture); 
	if(metmipmaps && netgeframebuffered) genereermipmaps();
	netgeframebuffered=false;            
}

GLuint framebufferobject::mijntexlocation()
{
	return renderedTexture;
}

void framebufferobject::tekentexture()
{
	bindtexture();
	tekenquad();
}

void framebufferobject::tekenquad()
{
	glBegin(GL_TRIANGLES); 
			glColor3f(1,1,1);
			glTexCoord2f(0,0); glVertex3f(0,0,0.0);
			glTexCoord2f(1,0); glVertex3f(W,0,0.0);
			glTexCoord2f(1,1); glVertex3f(W,H,0.0);

			glTexCoord2f(0,0); glVertex3f(0,0,0.0);
			glTexCoord2f(1,1); glVertex3f(W,H,0.0);
			glTexCoord2f(0,1); glVertex3f(0,H,0.0);
	glEnd();
}

int framebufferobject::getW()
{
	return W;
}
int framebufferobject::getH()
{
	return H;
}



void framebufferobject::saveaspng(const char *filename) //Crasht bij resolutie van 2048x2048...
{
	if(!metfloat)
	{
		printf("You are trying to write a png to %s, but this is not a floating point texture and your routine is not sophisticated enough to handle that eventuality.\n");
		return;
	}
	readtexdata();

	FILE *fp = fopen(filename, "wb");

	    if (!fp)
	       return ;

	png_structp png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);

	if (!png_ptr)
		return ;

	png_infop info_ptr = png_create_info_struct(png_ptr);

	if (!info_ptr)
	{
		png_destroy_write_struct(&png_ptr, (png_infopp)NULL);
		return ;
	}

	if (setjmp(png_jmpbuf(png_ptr)))
	{
		png_destroy_write_struct(&png_ptr, &info_ptr);
		fclose(fp);
		return ;
	}

	png_set_check_for_invalid_index(png_ptr, 0);

	png_set_filter(png_ptr, 0, PNG_FILTER_NONE);

	png_set_IHDR(png_ptr, info_ptr, W, H, 8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);

	png_init_io(png_ptr, fp);

	png_write_info(png_ptr, info_ptr);
	
	
	char texbytes[H][W*3];
	
	png_byte *row_pointers[H];
	
	float r,g,b;
	for(int y=0;y<H;y++)
	{
		row_pointers[y]=(png_byte*)(texbytes[y]);
		for(int x=0;x<W;x++)
		{
			r=(texturedata[(y*W*3)+(x*3)+0]*255.0f);
			g=(texturedata[(y*W*3)+(x*3)+1]*255.0f);
			b=(texturedata[(y*W*3)+(x*3)+2]*255.0f);
			if(r<0) 	r=0.0f;
			if(r>255) 	r=255.0f;
			if(g<0) 	g=0.0f;
			if(g>255) 	g=255.0f;
			if(b<0) 	b=0.0f;
			if(b>255) 	b=255.0f;
			texbytes[y][(x*3)+0]=(char)r;
			texbytes[y][(x*3)+1]=(char)g;
			texbytes[y][(x*3)+2]=(char)b;
		}
	}

	
	png_write_image(png_ptr, row_pointers);
	
	png_write_end(png_ptr, info_ptr);

	png_destroy_write_struct(&png_ptr, &info_ptr);

	fclose(fp);
       	
}


panorama::panorama()
{
	ikbenvers=true;
	panbufs=NULL;
	samenzicht[0]=NULL;
	samenzicht[1]=NULL;
}

panorama::~panorama()
{
	for(int i=0;i<2;i++)
	{
		if(samenzicht[i]!=NULL) delete samenzicht[i];
		samenzicht[i]=NULL;
	}



	for(int i=0;i<mijnbufaantal;i++)
		delete panbufs[i];
	delete[] panbufs;
	panbufs=NULL;
	delete[] mijnhoekpercel;
	mijnhoekpercel=NULL;
	delete mijnoogindeling;
	mijnoogindeling=NULL;
}

void panorama::initialiseer(int segmenten,float totalehorizonhoek,int totalepanresolutie,GLhandleARB diepteverwerkerp)
{
	if(totalepanresolutie<segmenten) totalepanresolutie=segmenten;
	if(totalehorizonhoek>360.0f)totalehorizonhoek=360.0f;
	mijnbufaantal=segmenten;
	if(mijnbufaantal<=0)mijnbufaantal=1;
	mijntotaleresolutie=totalepanresolutie;
	mijntotalehorizontalehoek=totalehorizonhoek;
	bool gaatierond=false;
	if(mijntotalehorizontalehoek>=359.0f) gaatierond=true;
	ikgarond=gaatierond;
	segmenthoek=mijntotalehorizontalehoek/((float)mijnbufaantal);
	
	panbufs=new framebufferobject*[mijnbufaantal];
	mijnhoekpercel=new float[mijntotaleresolutie];
	
	if(!SINEGRADIENT)
	{
		for(int i=0;i<mijnbufaantal;i++)
			panbufs[i]=new framebufferobject((int)(mijntotaleresolutie/mijnbufaantal),mijntotalehorizontalehoek/((float)mijnbufaantal),0.1f);
		
		double hoekstepsize=(M_PI*2.0)/((double)mijntotaleresolutie);
		for(float i=0;i<mijntotaleresolutie;i++)
			mijnhoekpercel[(int)i]=-M_PI+(hoekstepsize*i);
		
	}else{
		float opgeteldesegmentlengtes=0;
		float hoekpersegment=((mijntotalehorizontalehoek/180.0)*M_PI)/((float)mijnbufaantal);
		for(int i=0;i<mijnbufaantal;i++)
			opgeteldesegmentlengtes+=1.0/(CONSTANTADDITIVESINEGRADIENT+fabs(sin(hoekpersegment*(i+0.5))));
		float resolutiemult=((float)mijntotaleresolutie)/opgeteldesegmentlengtes;
		printf("opgeteldesegmentlengtes=%f resolutiemult=%f totaleingestelderesolutie=%d\n",opgeteldesegmentlengtes,resolutiemult,mijntotaleresolutie);
		int runningcounter=0;
		float currentangle=((mijntotalehorizontalehoek/360.0)*-M_PI);
		for(int i=0;i<mijnbufaantal;i++)
		{
			int panwidth=(int)(resolutiemult*(1.0/(CONSTANTADDITIVESINEGRADIENT+fabs(sin(hoekpersegment*(i+0.5))))));
			if(panwidth<2) panwidth=2;
			if(i==mijnbufaantal-1) panwidth=mijntotaleresolutie-runningcounter; //anders komt het niet uit..
			printf("panwidth[%d]=%d --- ",i,panwidth);
			panbufs[i]=new framebufferobject(panwidth,mijntotalehorizontalehoek/((float)mijnbufaantal),0.1f);
			
			for(int i=runningcounter;i<runningcounter+panwidth;i++)
			{
				mijnhoekpercel[(int)i]=currentangle;
				currentangle+=(hoekpersegment/((float)panwidth));
			}
			runningcounter+=panwidth;	
		}
		
		printf("totaleresolutie van panbufs samen=%d\n",runningcounter);
	}
	
	mijnoogindeling=new framebufferobject(mijntotaleresolutie, 1,false,false,gaatierond,false,true);
	
	mijnoogindeling->bindframebuffer(); //writing beta's and sin(alpha)'s tot oogindeling for use in horizonfacetten.distcalc
	glLoadIdentity();
	glClearColor(0.0,0.0,0.0,0.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glUseProgramObjectARB(0);
	
	glDisable(GL_TEXTURE_2D);	
		
	glBegin(GL_POINTS);
	for(int i=0;i<mijntotaleresolutie;i++) //l-receptor is texcoord-1 pixel, r-receptor = texcoord zelf
	{
		
		float alpha;
		if(i==0) alpha=mijnhoekpercel[i]-((mijntotalehorizontalehoek/360.0)*-M_PI);
		else	alpha=mijnhoekpercel[i]-mijnhoekpercel[i-1];
		glColor3f(fabs(mijnhoekpercel[i]),fabs(alpha),0.0);
		glVertex3f(i,0,0);
	}
	glEnd();		
	glEnable(GL_TEXTURE_2D);
	
	samenzicht[0]=new framebufferobject(mijntotaleresolutie, VERTICAALMINDER,false,false,gaatierond,false,true);
	samenzicht[1]=new framebufferobject(mijntotaleresolutie, VERTICAALMINDER,false,false,gaatierond,false,true);

	ikbenvers=false; //doe ik hier pas want als er dan iets misgaat dan gebeurt er verder in ieder geval niks geks omdat ie dan niet gelooft dat ie onvers is
	cur=0;
	mijndiepteverwerkerp=diepteverwerkerp;
}

void panorama::bindoogindelingtexture()
{
	mijnoogindeling->bindtexture();
}

float *panorama::geefmijnhoekpercel()
{

	return mijnhoekpercel;
}

bool panorama::checkversheid()
{
	if(ikbenvers)
		printf("Je kunt helemaal niks doen met een panorama als je die niet eerst initialiseert...\n");
		
	return ikbenvers;
}

int panorama::clampbuf(int bufnum)
{
	if(bufnum<0)bufnum=0;
	if(bufnum>=mijnbufaantal) bufnum=mijnbufaantal-1;
	return bufnum;
}

void panorama::bindrenderbuffer(int bufnum)
{
	//if(checkversheid())return;	//merk ik vanzelf wel..
	panbufs[clampbuf(bufnum)]->bindframebuffer();
}



void panorama::lijmbuffers()
{
	samenzicht[0]->bindframebuffer();
	glLoadIdentity();
	glUseProgramObjectARB(0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	float horireso=mijntotaleresolutie;
	float step=horireso/((float)mijnbufaantal);
	if(SINEGRADIENT) step=panbufs[0]->getW();
	float basisval=0.0;
	for(int i=0;i<mijnbufaantal;i++)
	{
		if(i>0)
		{
			if(SINEGRADIENT){
				basisval+=panbufs[i-1]->getW();
				step=panbufs[i]->getW();
			}else{
				basisval+=step;
			}
		}

		panbufs[i]->bindtexture();
		glBegin(GL_TRIANGLES); 
			glColor3f(1,1,1);
			glTexCoord2f(0,0); glVertex3f(basisval,0,0.0);
			glTexCoord2f(1,0); glVertex3f(basisval+step,0,0.0);
			glTexCoord2f(1,1); glVertex3f(basisval+step,samenzicht[0]->getH(),0.0);

			glTexCoord2f(0,0); glVertex3f(basisval,0,0.0);
			glTexCoord2f(1,1); glVertex3f(basisval+step,samenzicht[0]->getH(),0.0);
			glTexCoord2f(0,1); glVertex3f(basisval,samenzicht[0]->getH(),0.0);
		glEnd();
	}
	
	
	
	samenzicht[1]->bindframebuffer();
	glLoadIdentity();
	glUseProgramObjectARB(mijndiepteverwerkerp);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	horireso=mijntotaleresolutie;
	step=horireso/((float)mijnbufaantal);
	if(SINEGRADIENT) step=panbufs[0]->getW();
	basisval=0.0;
	
	for(int i=0;i<mijnbufaantal;i++)
	{
		if(i>0)
		{
			if(SINEGRADIENT){
				basisval+=panbufs[i-1]->getW();
				step=panbufs[i]->getW();
			}else{
				basisval+=step;
			}
		}
		
		panbufs[i]->binddepthtexture();
		glBegin(GL_TRIANGLES); 
			glColor3f(1,1,1);
			glTexCoord2f(0,0); glVertex3f(basisval,0,0.0);
			glTexCoord2f(1,0); glVertex3f(basisval+step,0,0.0);
			glTexCoord2f(1,1); glVertex3f(basisval+step,samenzicht[1]->getH(),0.0);

			glTexCoord2f(0,0); glVertex3f(basisval,0,0.0);
			glTexCoord2f(1,1); glVertex3f(basisval+step,samenzicht[1]->getH(),0.0);
			glTexCoord2f(0,1); glVertex3f(basisval,samenzicht[1]->getH(),0.0);
		glEnd();
	}
	
	
}

void panorama::bindzichttexture()
{
	//if(checkversheid())return;
	samenzicht[0]->bindtexture();
}

void panorama::binddieptetexture()
{
	//if(checkversheid())return;
	samenzicht[1]->bindtexture();
}

float panorama::geteffectievetotaleperspectief()
{
	if(mijnbufaantal%2==0) return mijntotalehorizontalehoek;
	else return mijntotalehorizontalehoek+segmenthoek;
}

float panorama::getnear()
{
	panbufs[0]->getnear(); //als de panbufs niet allemaal hetzelfde zijn moet je misschien minder makkelijk doen
}

float panorama::draaiwereld(int bufnum)
{
	int segment=clampbuf(bufnum);
	
	float beginhoek=-1.0*(mijntotalehorizontalehoek/2.0);
	//Als oneven aantal segmenten dan ligt de middelste precies rechtvooruit wat ook de beginpositie is
	//Dus ook over kwartslag naar links, maw het is goed om dan de totalehorizontalehoek
	if(mijnbufaantal%2==1) beginhoek+=segmenthoek;
	
	return beginhoek+(bufnum*segmenthoek);
}

bool panorama::getgaatierond()
{
	return ikgarond;
}
	
void panorama::verwerk()
{

}

float panorama::tothoek()
{
	return mijntotalehorizontalehoek;
}

horizonfacetten::horizonfacetten()
{
	mijnaantalcellen=0;
}
horizonfacetten::~horizonfacetten()
{
	delete facetten;
	delete output;
	delete maxoutput;
	delete distoutput;
	delete disttussenstap;
	delete[] dists;
}


void horizonfacetten::initialiseer(panorama *datahaalpunt,int aantalcellen,int tijdresolutie,GLhandleARB bewegingsdetectiep,GLhandleARB prefilterp,GLhandleARB edgep,GLhandleARB distcalcp)
{
	mijnpanorama=datahaalpunt;
	mijntijdresolutie=tijdresolutie;
	mijncounter=0;
	
	facetten=new framebufferobject(aantalcellen, tijdresolutie,false,false,datahaalpunt->getgaatierond(),false,true);
	output=new framebufferobject(aantalcellen, tijdresolutie,false,false,  datahaalpunt->getgaatierond(),false,true);
	maxoutput=new framebufferobject(aantalcellen, 1,false,false,  datahaalpunt->getgaatierond(),false,true);
	distoutput=new framebufferobject(aantalcellen, 1,false,false,  datahaalpunt->getgaatierond(),false,true);
	dists=new float[aantalcellen];
	disttussenstap=NULL;
	//speeds=new float[aantalcellen];
		
	mijnprefilterp=prefilterp;
	mijnbewegingsdetectiep=bewegingsdetectiep;
	mijnedgep=edgep;
	mijndistcalcp=distcalcp;
	mijndistverwerkerp=0;
	currenthoek=0;
	doeikdistbewerken=false;
	mijnaantalcellen=aantalcellen;
}

void horizonfacetten::zetdistbewerkerp(GLhandleARB distbewerkerp)
{
	
	mijndistverwerkerp=distbewerkerp;
	if(!doeikdistbewerken) disttussenstap=new framebufferobject(mijnaantalcellen, 1,false,false,  mijnpanorama->getgaatierond(),false,true);
	doeikdistbewerken=true;
}

void horizonfacetten::zethoek(int h)
{
	currenthoek=h;
}

bool eerstedge=false;
void horizonfacetten::update()
{

	facetten->bindframebuffer();
	glLoadIdentity();
	if(eerstedge){
		glUseProgramObjectARB(mijnedgep);
		glUniform1f(glGetUniformLocation(mijnedgep, "panoramabreedtereciprocal") , 1.0/(mijnaantalcellen*1.0));
	}else{ 	glUseProgramObjectARB(mijnprefilterp);
		glUniform1f(glGetUniformLocation(mijnprefilterp, "panoramabreedtereciprocal") , 1.0/(mijnaantalcellen*1.0));
	}
	glActiveTexture(GL_TEXTURE0);
	mijnpanorama->bindzichttexture();
	
	glBegin(GL_LINES); 
		glColor3f(1,1,1);
		glTexCoord2f(0,0.5); glVertex3f(0.0,mijncounter,0.0);
		glTexCoord2f(1,0.5); glVertex3f(mijnaantalcellen,mijncounter,0.0);
	glEnd();
	
	mijncounter++;
	if(mijncounter>mijntijdresolutie) printf("Misschien moet je beter opletten want je probeert nu boven de tijdresolutie te tekenen\n");
}


void horizonfacetten::verwerkdata(float lengtestap)
{	
	//printf("lengtestap=%f\n",lengtestap);
	if(mijncounter<mijntijdresolutie-1) printf("Misschien moet je nog even wachten met data verwerken totdat mijncounter==mijntijdresolutie-1?\n");
	
	output->bindframebuffer();
	glLoadIdentity();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	if(!eerstedge){ glUseProgramObjectARB(mijnedgep);
			glUniform1f(glGetUniformLocation(mijnedgep, "panoramabreedtereciprocal") , 1.0/(mijnaantalcellen));
	}else{	glUseProgramObjectARB(mijnprefilterp);
		glUniform1f(glGetUniformLocation(mijnprefilterp, "panoramabreedtereciprocal") , 1.0/(mijnaantalcellen));
	}
	glActiveTexture(GL_TEXTURE0);
	facetten->bindtexture();
	
	drawtexturedquad(0.0,mijnaantalcellen,mijntijdresolutie,0.0);
	
	
	
	maxoutput->bindframebuffer();
	glLoadIdentity();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glUseProgramObjectARB(mijnbewegingsdetectiep);
	glUniform1f(glGetUniformLocation(mijnbewegingsdetectiep, "panoramabreedtereciprocal") , 1.0/(mijnaantalcellen));
	glActiveTexture(GL_TEXTURE0);
	output->bindtexture();
	glBegin(GL_LINES);
		glTexCoord2f(0.0,0.5); glVertex3f(0.0,0.0,0.0);
		glTexCoord2f(1.0,0.5); glVertex3f(mijnaantalcellen,0.0,0.0);
	glEnd();
	
	
	mijncounter=0;	
	
	if(!doeikdistbewerken) distoutput->bindframebuffer();
	else disttussenstap->bindframebuffer();
	glLoadIdentity();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	if(lengtestap==0.0)
	{
		if(doeikdistbewerken)
		{
			distoutput->bindframebuffer();
			glLoadIdentity();
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		}
				
		for(int x=0;x<mijnaantalcellen;x++)
		{
			dists[x]=0.0;
			//speeds[x]=0.0;
		}
		
		return;
	}
	
	
	
	glUseProgramObjectARB(mijndistcalcp);
	glUniform1f(glGetUniformLocation(mijndistcalcp,"M_PI"),M_PI);
	float hoekpercel=((float)mijnpanorama->tothoek())/((float)mijnaantalcellen);
	float radpercel=hoekpercel/180.0*M_PI;

	glUniform1f(glGetUniformLocation(mijndistcalcp,"snelheidradianmult"),((float)mijntijdresolutie)*radpercel);
	glUniform1f(glGetUniformLocation(mijndistcalcp,"mijntijdresolutie"),((float)mijntijdresolutie));
	//printf("radpercel=%f en gepasste val=%f\n",radpercel,((float)mijntijdresolutie)*radpercel);
	glUniform1f(glGetUniformLocation(mijndistcalcp,"lengtestap"),lengtestap);
	glUniform1f(glGetUniformLocation(mijndistcalcp,"maxdist"),MAXDIST);
	glUniform1f(glGetUniformLocation(mijndistcalcp,"breedtereciprocal"),1.0/mijnaantalcellen);
	
	if(SINEGRADIENT)
	{
		
		glActiveTexture(GL_TEXTURE1);
		mijnpanorama->bindoogindelingtexture();
	
	}
	glActiveTexture(GL_TEXTURE0);
	maxoutput->bindtexture();
	glBegin(GL_LINES);
		glTexCoord2f(0.0,0.5); glVertex3f(0.0,0.0,0.0);
		glTexCoord2f(1.0,0.5); glVertex3f(mijnaantalcellen,0.0,0.0);
	glEnd();
	
	if(doeikdistbewerken)
	{
		distoutput->bindframebuffer();
		glLoadIdentity();
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		
		glUseProgramObjectARB(mijndistverwerkerp);
		glUniform1f(glGetUniformLocation(mijndistverwerkerp,"breedtereciprocal"),1.0/mijnaantalcellen);
		glUniform1f(glGetUniformLocation(mijndistverwerkerp,"mijntijdresolutie"),((float)mijntijdresolutie));
		glActiveTexture(GL_TEXTURE0);
		disttussenstap->bindtexture();
		glBegin(GL_LINES);
			glTexCoord2f(0.0,0.5); glVertex3f(0.0,0.0,0.0);
			glTexCoord2f(1.0,0.5); glVertex3f(mijnaantalcellen,0.0,0.0);
		glEnd();
	
	}
	
	float *texdatapointer=distoutput->readtexdata();
	
	for(int i=0;i<mijnaantalcellen;i++)
	{
		dists[i]=(texdatapointer[(i*3)])*MAXDIST;
		//printf("dists[%d]=%f\n",i,dists[i]);
	}
	
}

void horizonfacetten::geefvertexengevondenafstanden(vect bijpos,float bijrot,vect kleur,wereld *dewereld)
{

	float *pointingtothehoeken=mijnpanorama->geefmijnhoekpercel();
	const float maxdist=MAXDIST;
	for(int i=0;i<mijnaantalcellen;i++)
	{
		if(dists[i]>0.0 && dists[i]<=maxdist)
		{
			
			float hoek=pointingtothehoeken[i];
			float gradenhoek=(hoek/M_PI)*180.0;
			//((float)(i-(mijnaantalcellen/2.0)))*(((float)mijnpanorama->tothoek())/((float)mijnaantalcellen));
			const float dodehoek=DODEHOEK;
			
			if(!((gradenhoek>-dodehoek && gradenhoek<dodehoek) || (gradenhoek<-1*(180.0-dodehoek) || gradenhoek > (180.0-dodehoek))))
			{

				hoek+=bijrot;
				float dist=dists[i];
			
				//printf("Yo! Tekenen :)\ndists[%d]=%f en hoek=%f\n",i,dist,hoek);
			
				vect hoekkleur(0.0);	
		if(true){		float derdedeel=(M_PI*2)/3.0;
				float hoekcheckval=hoek+M_PI-bijrot;
				while(hoekcheckval<0) hoekcheckval+=M_PI*2;
				while(hoekcheckval>M_PI*2) hoekcheckval-=M_PI*2;
				//if(hoekcheckval<derdedeel) hoekkleur.x=1.0;
				//else if(hoekcheckval<derdedeel*2) hoekkleur.y=1.0;
				//else hoekkleur.z=1.0;
			
				hoekkleur.x=0.5+0.5*cosf(hoekcheckval);
				hoekkleur.y=0.5+0.5*cosf(hoekcheckval-derdedeel);
				hoekkleur.z=0.5+0.5*cosf(hoekcheckval-(2.0*derdedeel));
				float alpha=ALPHAPUNTJES;
				if(!TEKENDANSALPHA) alpha=1.0;
				glColor4f(hoekkleur.x,hoekkleur.y,hoekkleur.z,alpha);
		}else{
				//colorvect(vectmult(hoekkleur,1.0-sqrtf((dist/maxdist))));	
				hoekkleur.x=((dist/maxdist)*(dist/maxdist));
				hoekkleur.y=1.0-((dist/maxdist)*(dist/maxdist));
				hoekkleur.z=0.5+0.5*sinf(hoek);;
				glColor4f(hoekkleur.x*1.0-((dist/maxdist)),hoekkleur.y*1.0-((dist/maxdist)),hoekkleur.z*1.0-((dist/maxdist)),1.0-((dist/maxdist)));
			}
					
				float x=cosf(hoek)*dist;
				float y=sinf(hoek)*dist;
				
				x+=bijpos.x;
				y+=bijpos.z;
			
				//colorvect(vectmult(kleur,0.8));
				float RRR=dewereld->getradius();
				if(x>RRR)x-=RRR+RRR;
				if(x<-RRR)x+=RRR+RRR;
				if(y>RRR)y-=RRR+RRR;
				if(y<-RRR)y+=RRR+RRR;
				
				dewereld->iserraakgeschoten(x,y,bijpos);
				glVertex3f(x,y,0.0);
			}
		}
	}	
	
	
	
}



void horizonfacetten::bindtexture(int i)
{
	switch(i)
	{
	case 0:
		facetten->bindtexture();
		break;
	case 1:	
		output->bindtexture();
		break;
	case 2:	
		maxoutput->bindtexture();
		break;
	default:
		distoutput->bindtexture();
	}	
}


voetstaarder::voetstaarder()
{	
	oog=NULL;
	lijn=NULL;
	mijntijdresolutie=0;
	mijnretinadiameter=0;
	mijnaantalrichtingen=0;
	mijnkijkhoek=0;
}

voetstaarder::~voetstaarder()
{
	if(oog!=NULL) delete oog;
	oog=NULL;
	if(lijn!=NULL)
	{
		for(int i=0;i<mijnaantalrichtingen;i++)
		{
			for(int ii=0;ii<4;ii++)
				delete lijn[i][ii];
			delete[] lijn[i];
		}
		delete[] lijn;
	}
	lijn=NULL;
	
	if(avgvals!=NULL) delete avgvals;
	avgvals=NULL;
}

void voetstaarder::switchstrategie()
{
	grootstecontinugebruiken=!grootstecontinugebruiken;
}

void voetstaarder::initialiseer(int retinadiameter,int aantalrichtingen,int tijdresolutie,float kijkhoek,float oogmult,GLhandleARB bewegingsdetectiep,GLhandleARB prefilterp,GLhandleARB edgep)
{
	mijnbewegingsdetectiep=bewegingsdetectiep;
	mijnprefilterp=prefilterp;
	mijnedgep=edgep;
	
	uitkomstenpos.zetmij(0,0,0);
	mijntijdresolutie=tijdresolutie;
	mijnretinadiameter=retinadiameter;
	mijnaantalrichtingen=aantalrichtingen;
	mijnkijkhoek=kijkhoek;
	mijnslicecounter=0;
	mijnwereldradius=-1;
	hoevaakgereset=0;
	grootstecontinugebruiken=false; //counten werkt beter, bij raakt spoor minder snel bijster
	
	avgvals=new float[mijnaantalrichtingen];
	lijn=new framebufferobject**[mijnaantalrichtingen];
	for(int i=0;i<mijnaantalrichtingen;i++)
	{
		lijn[i]=new framebufferobject*[4];//0=program(0); 1=door blur heen gehaald,2=door edgefilter gehaald;3=door bewegingsdetectie heengehaald;
		lijn[i][0]=new framebufferobject(mijnretinadiameter,mijntijdresolutie,false,false,false,false,true);
		lijn[i][1]=new framebufferobject(mijnretinadiameter,mijntijdresolutie,false,false,false,false,true);
		lijn[i][2]=new framebufferobject(mijnretinadiameter,mijntijdresolutie,false,false,false,false,true);
		lijn[i][3]=new framebufferobject(mijnretinadiameter,1,false,false,false,false,true);
	}

	
	oog=new framebufferobject(mijnretinadiameter*oogmult,mijnretinadiameter*oogmult,true,true,false,true,true,false,mijnkijkhoek);
}

void voetstaarder::bindoogfb()
{
	
	oog->bindframebuffer();
}

void voetstaarder::bindtexture(int i)
{
	if(i==0 || i> mijnaantalrichtingen*4) oog->bindtexture();
	else{
		i--;
		lijn[(i-(i%4))/4][i%4]->bindtexture();
	}

}

void voetstaarder::takeaslice()
{
	//eerst lijnen uit oog extraheren
	oog->genereermipmaps();
	float hoekstap=M_PI/((float)mijnaantalrichtingen);
	for(int r=0;r<mijnaantalrichtingen;r++)
	{
		lijn[r][0]->bindframebuffer();
		glLoadIdentity();
		glActiveTexture(GL_TEXTURE0);
		oog->bindtexture();
		glBegin(GL_LINES);
			glTexCoord2f(0.5+0.5*sinf(hoekstap*r),0.5+0.5*cosf(hoekstap*r)); 		glVertex3f(0,mijnslicecounter,0);
			glTexCoord2f(0.5+0.5*sinf(M_PI+hoekstap*r),0.5+0.5*cosf(M_PI+hoekstap*r)); 	glVertex3f(mijnretinadiameter,mijnslicecounter,0);
		glEnd();
		
	}
	mijnslicecounter++;
}

float voetstaarder::welkerichtinggaikop()
{
	return mijnrichting;
}

vect voetstaarder::verwerkdata(vect bijwarp)
{
	
	if(mijnslicecounter<mijntijdresolutie) {printf("Ik heb zo het idee dat je verwerkdata te vroeg aanroept, welkom in de afgrond dan..\n"); exit(-1);}
	mijnslicecounter=0;
	//eerst lijnen uit oog extraheren //gebeurd in takeaslice()
	
	//dan lijnen blurren
	for(int r=0;r<mijnaantalrichtingen;r++)
	{
		
		lijn[r][1]->bindframebuffer();
		glLoadIdentity();
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glUseProgramObjectARB(mijnprefilterp);
		glUniform1f(glGetUniformLocation(mijnprefilterp, "panoramabreedtereciprocal") , 1.0/(mijnretinadiameter));
		glActiveTexture(GL_TEXTURE0);
		lijn[r][0]->bindtexture();
		drawtexturedquad(0,mijnretinadiameter,mijntijdresolutie,0);
		
		
	}
	
	
	//dan lijnen edgen
	
	for(int r=0;r<mijnaantalrichtingen;r++)
	{
		lijn[r][2]->bindframebuffer();
		glLoadIdentity();
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glUseProgramObjectARB(mijnedgep);
		glUniform1f(glGetUniformLocation(mijnedgep, "panoramabreedtereciprocal") , 1.0/(mijnretinadiameter));
		glActiveTexture(GL_TEXTURE0);
		lijn[r][1]->bindtexture();
		drawtexturedquad(0,mijnretinadiameter,mijntijdresolutie,0);
		
		
	}
	
	//dan bewegingsdetectie
	
	for(int r=0;r<mijnaantalrichtingen;r++)
	{
		lijn[r][3]->bindframebuffer();
		glLoadIdentity();
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glUseProgramObjectARB(mijnbewegingsdetectiep);
		glUniform1f(glGetUniformLocation(mijnbewegingsdetectiep, "panoramabreedtereciprocal") , 1.0/(mijnretinadiameter));
		glUniform1f(glGetUniformLocation(mijnbewegingsdetectiep, "kijkhoek") , (ODOKIJKHOEK/180.0)*M_PI);
		glActiveTexture(GL_TEXTURE0);
		lijn[r][2]->bindtexture();
		glBegin(GL_LINES);
			glTexCoord2f(0.0,0.5); glVertex3f(0.0,0.0,0.0);
			glTexCoord2f(1.0,0.5); glVertex3f(mijnretinadiameter,0.0,0.0);
		glEnd();
		
		
	}
	
	//dan texdata uitlezen en optellen, mogelijkerwijs rekening houdende met de hoek en dus hogere/lagere snelheid op retina? per lijn
	float counters[mijnaantalrichtingen];
	int grootstecontinu[mijnaantalrichtingen];
	float hoogstevelowithin[mijnaantalrichtingen];
	for(int r=0;r<mijnaantalrichtingen;r++)
	{
		hoogstevelowithin[r]=0;
		float *texpointer=lijn[r][3]->readtexdata();
		counters[r]=0;
		float tmp=0;
		avgvals[r]=0.0;
		int laatstelege=-1;
		grootstecontinu[r]=0;
		for(int i=0;i<mijnretinadiameter;i++)
		{
			tmp=-1.0*texpointer[i*3];//(texpointer[i*3]*-1)+(1*texpointer[(i*3)+1]);
			if(fabs(tmp)>fabs(hoogstevelowithin[r])) hoogstevelowithin[r]=tmp;
			
			if(fabs(tmp)>=0.01){
				counters[r]++;
				avgvals[r]+=tmp;
				
			}else{
				int afgelegdsindslaatstelege=i-(laatstelege+1);
				if(afgelegdsindslaatstelege>grootstecontinu[r])grootstecontinu[r]=afgelegdsindslaatstelege;
				laatstelege=i;
			}
			//if(fabs(tmp)>fabs(avgvals[r])) avgvals[r]=tmp;
		}	

		if(counters[r]==0) avgvals[r]=0.0;
		else avgvals[r]/=counters[r];
	}
			
	
	//uitkomst omzetten naar een vect, er vanuit gaande dat alle bijen op 1.0f unit hoog vliegen?
/*	int hoogsteval=0;
	for(int r=1;r<mijnaantalrichtingen;r++)
		if(fabs(avgvals[hoogsteval])<fabs(avgvals[r])) hoogsteval=r;
*/	

	//const bool grootstecontinugebruiken=true;
	int hoogstecountval=0;
	if(!grootstecontinugebruiken)
	{
		for(int r=1;r<mijnaantalrichtingen;r++)
			if(counters[hoogstecountval]<=counters[r]) hoogstecountval=r;
	}else{
		for(int r=1;r<mijnaantalrichtingen;r++)
			if(grootstecontinu[hoogstecountval]<=grootstecontinu[r]) hoogstecountval=r;
	}
	
	
	float hoekstap360=180.0/((float)mijnaantalrichtingen);
	
	//if(abs(avgvals[hoogsteval])==0.0) printf("Deze bij staat stil lijkt het wel..\n");
	//else printf("Deze hoek lijkt me realistisch: %f, met deze snelheid=%f\n",hoogsteval*hoekstap360,avgvals[hoogsteval]);
	
	float hoekstaprad=M_PI/((float)mijnaantalrichtingen);
	
	//avgvals[hoogstecountval]*=2*sinf(mijnkijkhoek/180.0*M_PI);// want zoveel is verhouding perspectief/hoogtebovengrond(1)
	float hoekpercel=mijnkijkhoek/((float)mijnretinadiameter);
	//float snelheidincellen=mijntijdresolutie*avgvals[hoogstecountval];// als avgvals 1.0 zou zijn dan zou dat betekenen dat er een snelheid van mijntijdresolutie cellen is gemeten.
	float snelheidincellen=mijntijdresolutie*hoogstevelowithin[hoogstecountval];// als avgvals 1.0 zou zijn dan zou dat betekenen dat er een snelheid van mijntijdresolutie cellen is gemeten.
	
	
	float snelheid=sinf((snelheidincellen*hoekpercel)/180.0*M_PI);
	if(snelheidincellen!=0.0) uitkomst.zetmij(sinf(hoogstecountval*hoekstaprad)*snelheid*2.0,0,-cosf(hoogstecountval*hoekstaprad)*snelheid*2.0);
	else uitkomst.zetmij(0,0,0);
//	printf("hoogstecountval[%d]=%f, hoogsteavgval[%d]=%f\n",hoogstecountval,counters[hoogstecountval],hoogstecountval,avgvals[hoogstecountval]);
	
	mijnrichting=hoogstecountval*hoekstaprad;
	uitkomstenpos.zetmij(vectplusvect(uitkomstenpos,uitkomst));
	
	const bool beterhoujejeafstandvanhuidigbijposgelijk=true;
	if(beterhoujejeafstandvanhuidigbijposgelijk)
	{
		uitkomstenpos.zetmij(vectplusvect(uitkomstenpos,bijwarp));
	}else{ // je kan natuurlijk ook gewoon zelf bepalen wanneer je over het randje bent gegaan..
		if(uitkomstenpos.x> mijnwereldradius) uitkomstenpos.x-=2*mijnwereldradius;
		if(uitkomstenpos.x<-mijnwereldradius) uitkomstenpos.x+=2*mijnwereldradius;
		if(uitkomstenpos.y> mijnwereldradius) uitkomstenpos.y-=2*mijnwereldradius;
		if(uitkomstenpos.y<-mijnwereldradius) uitkomstenpos.y+=2*mijnwereldradius;
		if(uitkomstenpos.z> mijnwereldradius) uitkomstenpos.z-=2*mijnwereldradius;
		if(uitkomstenpos.z<-mijnwereldradius) uitkomstenpos.z+=2*mijnwereldradius;
	}
	return uitkomst;

}

void voetstaarder::setinitialpos(vect bijpos,int wereldradius)
{
	uitkomstenpos.zetmij(bijpos);
	mijnwereldradius=wereldradius;
}
vect voetstaarder::oedipos()
{
	return uitkomstenpos;
}

vect voetstaarder::laatstestap()
{
	return uitkomst;
}

void voetstaarder::reset(vect nwpos)
{
	uitkomstenpos.zetmij(nwpos);
	hoevaakgereset++;
}
