#version 110

varying vec2 texcoord;
uniform sampler2D facetten; 
uniform sampler2D oogindeling;

uniform float M_PI;
uniform float lengtestap;
uniform float mijntijdresolutie;
uniform float maxdist;
uniform float breedtereciprocal;

void main()
{	

	/*
		als ik de hoek tussen iedere 2 receptoren kan ik daar rekening mee houden in de snelheid
		in een 32F texture kan ik op R de beta hoek in optical array zetten, in radians zelfs
		in G kan ik de interommatidiale afstand plaatsen, hier ook in radians :) maw: als snelheid is 1 tussen de 2 receptoren dan uhm.. betekent dat iets
		stel de afstand tussen twee receptoren is alpha radians, dan betekent een facettensnelheid van 1.0 dat die angulairesnelheid is behaald. Maw snelheid*sin(alpha) is de angulaire retinale snelheid
		Dus in G plaats je sin(alpha) of alpha... beter alpha
		
	
	
	*/

	vec4 m= (texture2D(facetten,texcoord));
	vec2 beta_alpha=texture2D(oogindeling,texcoord).rg;
	float snelheid=abs(m.r);//*snelheidradianmult;
	//if(texcoord.s>=0.5) snelheid=m.g;//*snelheidradianmult;
	
	if(snelheid<2.0/mijntijdresolutie) discard; //Anders tekent ie alle zwarte als heeeeeeel ver weg, heel veel overbodig vertexen en lelijke texture dan... Oftewel: De 0 snelheid hebbende..
	
	snelheid*=beta_alpha.g*mijntijdresolutie;
	if(snelheid>M_PI/2.0) discard; //mocht snelheid zo groot worden dan is het handig dat ie maximale waarde aanneemt
	
	
	float beta=(beta_alpha.r);
	
	float phi=M_PI-(snelheid+(M_PI-beta));


	
	float afstandtotpunt=(lengtestap/sin(snelheid))*sin(phi);
	
	//if(afstandtotpunt>maxdist) gl_FragColor=vec4(0.0);	
	//else 
	gl_FragColor=vec4(afstandtotpunt/maxdist);///maxdist);//sqrt(m-((l+r+ll+rr)*0.25));
	

}


